"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useMutator = void 0;

var _react = require("react");

var _lodash = require("lodash");

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var useMutator = function useMutator(initialState) {
  var _useState = (0, _react.useState)(initialState),
      _useState2 = _slicedToArray(_useState, 1),
      init = _useState2[0];

  var _useState3 = (0, _react.useState)(function () {
    return [init];
  }),
      _useState4 = _slicedToArray(_useState3, 2),
      state = _useState4[0],
      setState = _useState4[1];

  var _useState5 = (0, _react.useState)(function () {
    return function (fn) {
      var _state = _slicedToArray(state, 1),
          currentState = _state[0];

      if (fn === undefined) {
        return currentState;
      }

      var v = fn(currentState);

      if (!(0, _lodash.isEqual)(v, currentState)) {
        setState([state[0] = v]);
      }

      return v;
    };
  }),
      _useState6 = _slicedToArray(_useState5, 1),
      mutate = _useState6[0];

  var useMutations = function useMutations() {
    return state[0];
  };

  return [useMutations, mutate];
};

exports.useMutator = useMutator;
